package dbtest;

import java.sql.Connection;
import java.sql.DatabaseMetaData;
import java.sql.DriverManager;
import java.sql.SQLException;

import javax.sql.DataSource;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.config.AbstractFactoryBean;

public class TestFactory extends AbstractFactoryBean<Object> {
	private final Logger logger = LoggerFactory.getLogger(getClass());

	private DataSource dataSource;

	@Override
	public Class<? extends Object> getObjectType() {
		return Object.class;
	}

	@Override
	protected Object createInstance() throws Exception {
		DriverManager.setLogWriter(new java.io.PrintWriter(System.out));
		printOutDatabase();
		return null;
	}

	private void printOutDatabase() throws SQLException {
		Connection connection = null;
		try {
			connection = dataSource.getConnection();
			DatabaseMetaData databaseMetaData = connection.getMetaData();
			String databaseProductName = databaseMetaData.getDatabaseProductName();
			logger.warn("database product name: '" + databaseProductName + "'");

		} finally {

			if (connection != null) {
				connection.close();
			}

		}
	}

	public void setDataSource(DataSource dataSource) {
		this.dataSource = dataSource;
	}
}
